#include <qwidget.h>
#include <X11/Xutil.h>
#include <X11/extensions/Xvlib.h>
#include <linux/videodev.h>

class CamCtrlPanel;

class CamView: public QWidget {
  Q_OBJECT
public:
  bool initialized;

  CamView();
  ~CamView();
  virtual void paintEvent( QPaintEvent *e );
  virtual void resizeEvent( QResizeEvent *e );
  virtual void mousePressEvent( QMouseEvent *e );
  void captureLoop();
protected:
  CamCtrlPanel *ctrl_panel;
  bool panel_shown;
  char *buf0;
  int bufsize, video_xsize, video_ysize;

  Display *disp;
  XvPortID img_port;
  Window wout;
  int wout_height, wout_width;
  GC gc;
  XvImage *imgout;
  unsigned int fmt_id;
  bool lookup_rgb24, lookup_yuv420p, rgb_mode;

  int video_fd;
  video_mbuf vmbuf;
  video_mmap vmmap;
  char *video_map;

  bool xvInit();
  void xvCleanup();
  bool v4lInit();
  void v4lCleanup();
  int tryResolution( int new_xsize, int new_ysize );
protected slots:
  void disableScale( bool disable );
  void keepRatio( bool keep );
  void setResolution( int num );
  void setRate( int num );
  void setAutoGain( bool auto_gain );
  void setGain( int gain );
};

